module Walter
  class Tourguide
    include Singleton
    @tours = {}
    attr_accessor :reload

    def initialize
      super
      @reload = true
    end

    def tours
      load_tours
      @tours
    end

    def load_tours(tours_path=nil)
      return unless @reload

      @tours = {}
      tours_path ||= Rails.application.config.walter.tours_path
      tours_root = Pathname.new(Rails.root.join(tours_path))
      if Rails.root.join(tours_path).exist?
        Dir.glob(Rails.root.join("#{tours_path}/**/*.yml")).each do |yml|
          relative_filename = Pathname.new(yml).relative_path_from(tours_root)
          # `controller_path` is either "controller_name" or "module_name/controller_name"
          controller_path, filename = relative_filename.split
          file_parts = filename.to_s.split(".")
          action = file_parts[0]
          locale = file_parts[1]
          t = YAML.load_file(yml)
          @tours["#{controller_path}.#{action}.#{locale}"] = t
        end
      end
      puts "#{@tours.size} tours loaded"
      @reload = ENV['WALTER_RELOAD_TOURS'].present? || Rails.env.development?
    end
  end
end
